// RX(PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;

	//  ȃf[^ʒu
	struct fpos md[] =
	{
		{ 0x12, 0x01, 0x0c00 }, // 
		{ 0x13, 0x01, 0x0d00 }, // 
		{ 0x14, 0x01, 0x0f00 }, // 
		{ 0x15, 0x01, 0x0f00 }, // 
		{ 0x16, 0x01, 0x0e00 }, // 
		{ 0x17, 0x01, 0x0b00 }, // 
		{ 0x18, 0x01, 0x0d00 }, // 
		{ 0x19, 0x01, 0x0d00 }, // 
		{ 0x1c, 0x01, 0x2f00 }, // 
		{ 0x1f, 0x01, 0x0500 }, // 
		{ 0x20, 0x01, 0x0400 }, // 
		{ 0x21, 0x01, 0x0200 }, // 
		{ 0x22, 0x01, 0x0600 }, // 
		{ 0x23, 0x01, 0x0400 }, // 
		{ 0x24, 0x01, 0x0e00 }, // 
		{ 0x25, 0x01, 0x0300 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBXN
		if (disk.ReadDATA(0x00, 0x00, 0x00, 0x64, 0x01, buff, 0x100)==0x100)
		{
			printf("DISK AF܂.\n");
			fcut("DRIVER", 0x10, 0x08, 0x00, 0x01, 0x01, 0x0000, 0x1000);
		}
		else if (disk.ReadDATA(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100)==0x100)
		{
			printf("DISK BF܂.\n");
			for (i=0; md[i].size; i++)
			{
				// ȃf[^̐؂o
				sprintf(fname,"MUS%02d",i);
				fcut(fname, md[i].trk, md[i].trk>>1, md[i].trk&1, md[i].sec, 0x01, 0x0000, md[i].size);
			}
		}
	}
	return 0;
}

